#!/bin/bash
# 
# Licensed Materials - Property of IBM
#
# IBM Financial Crimes Insight with Watson PID 5900-A0H  
# IBM Financial Crimes Insight with Watson, Private PID 5737-E41
# 
# (C) Copyright IBM Corp. 2017, 2018  All rights reserved.
# 
# The source code for this program is not published or otherwise divested  
# of its trade secrets, irrespective of what has been deposited with the  
# U. S. Copyright Office. 
# 
# US Government Users Restricted Rights - Use, duplication or 
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

# fci-passwd <user>   with: MQM_PASSWORD environment variable

userid="$1"
if [ "$userid" = "" ]
then
        exit 1
fi

function xor_decode() {
         local source="$1"
         local decoded_int xored_int clear_char

         if [ "${source:0:5}" != "{xor}" ]
        then
                echo "$source" && return 0
        fi
         source=${source:5}

         local under="_"
         under_int=$( printf '%d' "'$under'" )
         decoded=$(echo "${source}" | base64 -d)
         for (( i=0; i < ${#decoded}; i++ )); do
                 decoded_int=$(printf '%d' "'${decoded:$i:1}'")
                 xored_int=$(( decoded_int ^ under_int ))
                 clear_char=$(echo $xored_int | awk '{printf("%c",$1)}')
                 result+="$clear_char"
         done
         echo "$result"
}

rc=0
while true
do
        if [  -z "${MQM_PASSWORD+x}" ]
        then
                 break
        fi
        if [ "$MQM_PASSWORD" = "" ]
        then
                rc=126
                break
        fi
        decoded_password=$(xor_decode "$MQM_PASSWORD")
        sudo su - -c "echo $userid:$decoded_password | /usr/sbin/chpasswd"
        rc=$?
        break
done

exit $rc
